;************************************************************************
;                                                                     	*
;    Filename:	    2510-xx.asm                                       	*
;    Date:                                                            	*
;    File Version:                                                    	*
;                                                                     	*
;    Author:     Chernov                                    	*
;    Company:         						                         	*
;                                                                     	* 
;                                                                     	*
;*********************************************************************	*
;                                                                     	*
;    Files required:    							 	*
;                      									*
;                      													*
;						    										  	*
;                                              						  	*
;    -25		  056 370-07-10                	*
;*********************************************************************	*
;                                                                     	*
;    Notes:          							 					*
;					     HIH4000.          	*
;			          											*
;					 1.5          					  	*
;                                                                     	*
;	          															*
;			           										*
;			1.  /      						     	*
;			2.     				         	*
;			3.           				   	*
;			4.  /          						*
;			5.   1 									*
;			6.   2        							*
;			7. . .         							 	*
; Ch-3000_VLAJ_05.asm -  88   average                                                                    	*
; Ch-3000_VLAJ_05A.asm -  
;************************************************************************
;	list      p=16f819           ; list directive to define processor
;	#include <p16F819.inc>        ; processor specific variable definitions
;
;	errorlevel  -302              ; suppress message 302 from list file
;
;	__CONFIG   _CP_ALL & _WRT_ENABLE_1536 & _CPD_ON & _CCP1_RB3 & _DEBUG_OFF & _LVP_OFF & _BODEN_ON & _MCLR_ON & _WDT_ON & _PWRTE_ON & _INTRC_IO 

	list      p=16f88           	; list directive to define processor
	#include <p16F88.inc>        	; processor specific variable definitions

;	errorlevel  -302              	; suppress message 302 from list file
	errorlevel  2              	
	__CONFIG    _CONFIG1, _CP_ALL & _CCP1_RB3 & _DEBUG_OFF & _WRT_PROTECT_ALL & _CPD_ON & _LVP_OFF & _BODEN_ON & _MCLR_ON & _PWRTE_ON & _WDT_ON & _INTRC_IO
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.
	cblock	0x020

r_PORTB						; 
d_PORTB	
d_PORTA	
ind_1						;     
ind_2						;     
ind_3						;     

buf_ind_1					;   1 
buf_ind_2					;   2 
buf_ind_3					; 

temp1						;      
temp2						;      
perem5						; 

sred_hi_temp,sred_lo_temp,sred_hi,sred_lo,sred_dr,fssh,fssl
H_p_hi,H_p_lo,timcon 
adr_e						;     EEPROM
data_e						; 

flag_1						; 
flag_2						; 
flag_3						; 
flag_4						; 


H_izm_hi					;       1
H_izm_lo					;      


schet_sim1					;   
schet_sim2					;   

cher300_10					; 
cher02						; 
cher05						; 


period						;   
;========================================
flag_0						;* 
Hi_zad_hi,Hi_zad_lo			;*  

Gis_lo						;*  

k1_hi,k1_lo					;*   1
k2_hi,k2_lo					;*   2
k3_hi,k3_lo					;*   3
end_stek					;*
;========================================
uskor                       ;
flag_i1
flag_i2
reg_ind						;    
b_zad_ind


;========================================
;    
;========================================
; 
flag_s							; 
count							; 
;temp							; 
R3								; 
R2								; 
R1								; 
R0								; 

t_binh									; 9-16 
t_binl									; 0-8 
; 
binu							; 
binh							; 
binl							; 
; 
edin							; 
dest							; 
sotn							; 
tysc							; 
dtys							;  
stys							;  
mlon							; 
;========================================
;========================================
						;   
peAsu									; _
peAsh									; 
peAsl									; 
peBsu									; _
peBsh									; 
peBsl									; 
regsr									; 
flag_srv								; 
;========================================
peCsu									; _C
peCsh									; 
peCsl									; 
peDsu									; _D
peDsh									; 
peDsl									; 
temp   
sign
;========================================
avtovyh									;     

chtteep								    ;     EEPROM
;===================================


SIN_hi					    ; 
SIN_lo					  	;
sta_sis					  	;    


	endc

	cblock	0x07E	
w_temp           			; variable used for context saving 
status_temp        	 		; variable used for context saving
	endc
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;===========================================================================================

;#define		RB_1	PORTB,1		;  

#define		RB_2	PORTB,2		;   ()
#define		RB_3	PORTB,3		;  
#define		RB_4	PORTB,4		;  
#define		RB_5	PORTB,7		;   (     )

;#define		RB_6	PORTB,6		;  

#define		PORTKN	b'11111110'	;    
;===========================================================================================
;   
#define		S_A		d_PORTB,1	;  
#define		S_B		d_PORTB,2	;  B
#define		S_C		d_PORTB,3	;  C	
#define		S_D		d_PORTB,4	;  D
#define		S_E		d_PORTB,5	;  E 
#define		S_F		d_PORTB,6	;  F
#define		S_G		d_PORTB,7	;  G
#define		S_H		d_PORTA,6	;  H

#define		SOT		d_PORTA,1	;    
#define		DES		d_PORTA,2	;    
#define		EDI		d_PORTA,7	;    
;      
;  
;  
#define		CL_PA	b'00011001'	;    "0"      , "1"           
#define		SE_PA	b'01000000'	;      "1"         
;  
#define		CL_PB	b'00000001'	;    "0"      , "1"           
#define		SE_PB	b'11111110'	;      "1"         
;===========================================================================================
#define		DIND	.10					;      (  - .7 )

#define		TOCHKA1		flag_i1,0		;    
#define		TOCHKA2		flag_i1,1		; 
#define		TOCHKA3		flag_i1,2		; 
#define		TOCHm1		flag_i1,4		;    
#define		TOCHm2		flag_i1,5		; 1 -    2 .
#define		TOCHm3		flag_i1,6		; 0 -  
#define		RAZR1		flag_i2,0		;    
#define		RAZR2		flag_i2,1		; 0 -  
#define		RAZR3		flag_i2,2		; 1 -    2 .

;-----------------------------------
#define		ON_OFF	flag_0,0			;   1- 0-
#define		UV_OS	flag_0,1			;    0-, 1-

#define		B_MIG	flag_1,0			;   (1 , 0 )
#define		E_data	flag_1,1			;   
#define		SR		flag_1,2			;  
#define		MINUS	flag_1,3			;    

;-----------------------------------
#define		ONF		flag_2,0			;   1- 0-
#define		TUM		flag_2,1			;    
#define		UGZ		flag_2,2			;  
#define		TDO		flag_2,3			;   /
#define		KK1		flag_2,4			;    1 
#define		KK2		flag_2,5			;    2
#define		KK3		flag_2,6			;    3
#define		IZG		flag_2,7			;   
;-----------------------------------
#define		ERROR_D	flag_2,6			;  

#define		KL_F	flag_3,0			;   
#define		KL_U	flag_3,1			;   
#define		KL_D	flag_3,2			;   
#define		IT		flag_3,3			;    
#define		UST		flag_3,4			;    
#define		kl_no	flag_3,5			;   
#define		vp_rp	flag_3,6			;   0- , 1- ,
;#define		RAKTD	flag_3,7			;      . 
;-----------------------------------
#define		BTE		flag_4,0			;      00
#define		IZM		flag_4,1			; 
#define		RELE1	flag_4,2			;   
#define		RELE2	flag_4,3			;   
#define		STAR_IN	flag_4,4			;   	
#define		B24		flag_4,5	;
#define		BTE0_00	flag_4,6	;

;-----------------------------------
#define		RAV			flag_srv,0		;   =
#define		BOL			flag_srv,1		;   >
#define		MEN			flag_srv,2		;   <
#define		BOL_RAV		flag_srv,3		;   >=
#define		MEN_RAV		flag_srv,4		;   <=

#define		IZM_ACP		ADCON0,2		;    
;-----------------------------------

#define		T_ZAV		.250			;  
#define		Tmax_hi		0x03			; 99   
#define		Tmax_lo		0xde			; 
#define		Tmin_hi		0x00			;
#define		Tmin_lo		0x02			; 0,1   

#define		G_ZAV	.10					;  
#define		G_MAX	.250				; 25  
#define		G_MIN	.5					; 0  

#define		D_ZAV	.0					;   (   )
#define		D_MAX	.250				; 25  
#define		D_MIN	.0					; 0   - 0  

#define		K_ZAV	.30					;   (  )
#define		K_MAX	.100				; 100  
#define		K_MIN	.10					; 10   

#define		PERIZM	.1					;   
;============================================================================================
;======================================================================================
;  
#define		c0		b'01111110'	; 0-0
#define		c1		b'00001100'	; 1-1
#define		c2		b'10110110'	; 2-2 "z"
#define		c3		b'10011110'	; 3-3
#define		c4		b'11001100'	; 4-4 ""
#define		c5		b'11011010'	; 5-5 "S"
#define		c6		b'11111010'	; 6-6
#define		c7		b'00001110'	; 7-7
#define		c8		b'11111110'	; 8-8
#define		c9		b'11011110'	; 9-9
;======================================================================================
#define		c_		b'00000000'	;  "" 
#define		cM		b'10000000'	;  "-"
#define		cn		b'10101000'	; "n"
#define		cN		b'01101110'	; ""
#define		co		b'10111000'	; "o" 
#define		cE		b'11110010'	; "E"
#define		cr		b'10100000'	; "r"
#define		cd		b'10111100'	; "d"
#define		cb		b'11111000'	; "b"
#define		ct		b'11110000'	; "t"
#define		cA		b'11101110'	; "A"
#define		cC		b'01110010'	; "C"
#define		cH		b'11101100'	; "H"
#define		cP		b'11100110'	; "P"
#define		cc		b'10110000'	; "c"
#define		ch		b'11101000'	; "h"
#define		cL		b'01110000'	; "L"
#define		ci		b'00100000'	; "i"
#define		cg		b'11001110'	; "g"
#define		cF		b'11100010'	; "F"
#define		cU		b'01111100'	; "U"
#define		cu		b'00111000'	; "u"
#define		cY		b'11011100'	; ""

;======================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
			ORG		0x000      	   		; processor reset vector
 			nop
			goto	main           		; go to beginning of program
;============================================================================================
			ORG    	0x004          		; interrupt vector location
			movwf  	w_temp         		; save off current W register contents
			movf	STATUS,w       	 	; move status register into W register
			movwf	status_temp    	 	; save off contents of STATUS register

			clrf	STATUS				;   0
;===============================================
			bcf		T1CON,TMR1ON		;  ,
			bcf		PIR1,TMR1IF			;      1
			movlw	0xfc				; 
			movwf	TMR1H				; 
			movlw	0xfd				; 
			movwf	TMR1L				; 
;==============  	300 	
;========================================================================== 
;==============	    
			movf	b_zad_ind,f			;    
			BZ		$+2					;
			decf	b_zad_ind,f			; 
;==============	   
			call	indic				;
;========================================================================== 
			decfsz	cher300_10,f		;     10  
			goto	end_pr				; 
			movlw	.30					;     
			movwf	cher300_10			;
;========================================================================== 
;========  	10 		
;========================================================================== 
			decfsz	cher05,f			;     2  
			goto	end_pr				; 
			movlw	.5					;     
			movwf	cher05				;
;========================================================================== 
;==============  	2 
			btfss	B_MIG				;    
			goto	$+3					;
			bcf		B_MIG				;
			goto	$+2					;
			bsf		B_MIG				;
;========================================================================== 			
			decfsz	cher02,f			;     1  
			goto	end_pr				; 
			movlw	.2					;     
			movwf	cher02				;  1 
;==========================================================================
;==============  	1  start		;				

			decfsz	period,f			;    (20  *4 = 160  )
		goto	$+.4					; 
			movlw	PERIZM				; 
			movwf	period				; 
			bsf		IZM					;   20 
			
			;==============				;
			movf	avtovyh,f			;   
			SKPNZ						;
		goto	chet_1mi_m			;
			decfsz	avtovyh,f			;
		goto 	chet_1mi_m			;
			call	zap_eeprom			;     
			bcf		UST					;    
			clrf	flag_2				;    			
			bcf		vp_rp				;   0- 		
			bcf		KL_U				;   
			bsf		KL_D				;
			;==============				;
;===============================================				
chet_1mi_m								;	
			incf	sta_sis,f			;   .
			btfsc	sta_sis,5			; 
			bsf		STAR_IN				; 
;==========================================================================
;==============  	1  end
;=================================
;=================================
;=================================
;=================================
end_pr
			bsf		T1CON,TMR1ON	;  ,

			movf    status_temp,w   ; retrieve copy of STATUS register
			movwf	STATUS          ; restore pre-isr STATUS register contents
			swapf   w_temp,f     	; 
			swapf   w_temp,w     	; restore pre-isr W register contents
		retfie              	   	; return from interrupt
;============================================================================================
;*************************************************************************************************************************************************
deshif		addwf	PCL,f			;  
			retlw	b'01111110'		; "0"
			retlw	b'00001100'		; "1"
			retlw	b'10110110'		; "2"
			retlw	b'10011110'		; "3"
			retlw	b'11001100'		; "4"
			retlw	b'11011010'		; "5"
			retlw	b'11111010'		; "6"
			retlw	b'00001110'		; "7"
			retlw	b'11111110'		; "8"
			retlw	b'11011110'		; "9"
			retlw	b'00000000'		; "10"-""
			retlw	b'10000000'		; "11"-""				
;*************************************************************************************************************************************************
;*******************************************************************************************************************************************
text_1		addwf	PCL,f			;   (   0)
			retlw	.12				;   - retlw  
			retlw	cC		; "C"
			retlw	cH		; "H"
			retlw	cM		; "-"
			retlw	c3		; "3"
			retlw	c8		; "8"
			retlw	c0		; "0"
			retlw	c0		; "0"
			retlw	cM		; "-"				
			retlw	c1		; "1"
			retlw	c1		; "1"
			retlw	cA		; "A"
					;	.12  
			retlw	.12				;   - retlw  
			retlw	b'11110010'		; "E"
			retlw	b'10100000'		; "r"
			retlw	b'10100000'		; "r"
			retlw	b'10111000'		; "o"
			retlw	b'10100000'		; "r"
			retlw	b'00000000'		; " "
			retlw   b'10111100'		; "d"
			retlw   b'11101110'		; "a"				
			retlw	b'11110000'		; "t"
			retlw	b'10110000'		; "c"
			retlw	b'11101001'		; "h."
					;	.24  
			retlw	.16				;   - retlw  
			retlw	b'10000000'		; "-"
			retlw	b'01111110'		; "0"
			retlw	b'10000000'		; "-"
			retlw	b'11011010'		; "5"
			retlw	b'11111010'		; "6"
			retlw	b'10000000'		; "-"
			retlw	b'10011110'		; 3-3
			retlw	b'00001110'		; 7-7				
			retlw	b'11001100'		; "4"
			retlw	b'10000000'		; "-"
			retlw	b'01111110'		; "0"
			retlw	b'11001100'		; "4"					
			retlw	b'10000000'		; "-"
			retlw	b'01111110'		; "0"					
			retlw	b'11011010'		; "5"				
					;	.40  
			retlw	.10				;   - retlw  
			retlw	b'00000000'		; " "
			retlw	b'11110010'		; "E"
			retlw	b'10100000'		; "r"
			retlw	b'10100001'		; "r."
			retlw	b'00000000'		; " "
			retlw	b'10111100'		; "d"
			retlw	b'11101110'		; "A"
			retlw   b'11110000'		; "t"				
			retlw	b'11101110'		; "a"
					;	.50  
			retlw	.4				;   - retlw  
			retlw	b'10111000'		; "o"
			retlw	b'11100010'		; "F"
			retlw	b'11100010'		; "F"
					;	.54  
			retlw	.3				;   - retlw  
			retlw	b'10111000'		; "o"
			retlw	b'10101000'		; "n"
					;	.57 
			retlw	.4				;   - retlw  
			retlw	b'10000000'		; "-"
			retlw	b'10111000'		; "o"
			retlw	b'10000000'		; "-"
					;	.61 
			retlw	.4				;   - retlw  
			retlw	b'10000000'		; "-"
			retlw	b'01111100'		; "U"
			retlw	b'10000000'		; "-"
					;	.65 
			retlw	.4				;   +1
			retlw	b'11011100'		; ""
			retlw	b'01110010'		; ""
			retlw	b'11110000'		; "t"
					;	.69 tuc
			retlw	.4				;   +1
			retlw	b'11101100'		; "H"
			retlw	b'00111000'		; "u"
			retlw	b'10110000'		; "c"
					;	.73 qic
			retlw	.4				;   +1
			retlw	b'11001110'		; "q"
			retlw	b'00001000'		; "i"
			retlw	b'10110000'		; "c"
					;	.77 dot
			retlw	.4				;   +1
			retlw	b'11100010'		; "F"
			retlw	b'00111000'		; "u"
			retlw	b'10101000'		; "n"
					;	.81 Uu1 ---
			retlw	.4				;   +1
			retlw	b'01111100'		; "U"
			retlw	b'10110000'		; ""
			retlw	b'00001100'		; "1"
					;	.85 Tel
			retlw	.4				;   +1
			retlw	b'11110000'		; "t"
			retlw	b'11110010'		; "E"
			retlw	b'01110000'		; "L"
					;	.89 /
			retlw	.4				;   +1
			retlw	b'10100000'		; "r"
			retlw	b'11110010'		; "E"
			retlw	b'11001110'		; "q"
					;	.93  Uu2 ---
			retlw	.4				;   - retlw  
			retlw	b'01111100'		; "U"
			retlw	b'10110000'		; ""
			retlw	b'10110110'		; "2"
					;	.97  Uu2 ---
			retlw	.4				;   - retlw  
			retlw	b'01111100'		; "U"
			retlw	b'10110000'		; ""
			retlw	b'10011110'		; "3"
;============================================================================================
;============================================================================================
;============================================================================================
;   
main		movlw	0x5				; 
			movwf	FSR				; 
ClfMem		clrf	INDF			; 
			incf	FSR,f			; 
			movlw	0x80			;
			subwf	FSR,w			;
			BNZ 	ClfMem			;
;============================================================================================
; 
			BANKSEL OSCTUNE			
			clrf	OSCTUNE			;     
			movlw	b'01110000'		;  8 
			movwf	OSCCON			;
;			BANKSEL OPTION_REG		;    OPTION_REG
			movlw	b'00001111'		;   ( . ,   WDT, . 1:128)
			movwf	OPTION_REG		; 
			movlw	b'00000001'		;    A   R0  ,   
			movwf	TRISB			;
			movlw	b'00000001'		;  
			movwf	TRISA			; 
			BANKSEL PORTA			;   
			clrf	PORTA			;  
			clrf	PORTB			; 
		; 	
			BANKSEL ANSEL			; 
			movlw	b'00000001'		;
			movwf	ANSEL			; 1 			
			BANKSEL ADCON0			; 
			movlw	b'10000001'		; FOSC/64,  0,  
			movwf	ADCON0			; 			
			BANKSEL ADCON1
			movlw	b'11000000'		;  , Ft/2,  1/0   .
			movwf	ADCON1			; 			
		;  	TMP1	; 
			BANKSEL T1CON			;   0
			movlw	b'00110001'		;  ,  4  = 1:8 - 125 000 
			movwf	T1CON			;

;============================================================================================
;============================================================================================
			call	vost_data		;     
;============================================================================================
		;  
			movlw	.120			; 
			movwf	uskor			; 
			
			movlw	.2				;  10   1 
			movwf	cher300_10		; 
			movwf	cher02			; 
			movwf	cher05			; 

			
			bcf		KL_U			;    
			bsf		KL_D			;
			movlw	PERIZM			;   
			movwf	period			; 
;============================================================================================
		;  
			movlw	b'11000000'		;
			movwf	INTCON			;     
			bsf		STATUS,RP0		;   1
			bsf		PIE1,TMR1IE		;    TIMER1
			bcf		STATUS,RP0		;   0
;============================================================================================
	;    
			bsf		STATUS,RP0		;   1
			movlw	PORTKN			;      
			movwf	TRISB			; 			
			bcf		STATUS,RP0		;   0 
			btfss	RB_4			;     
		goto	vos_data			; 
			bsf		STATUS,RP0		;   1
			clrf	TRISB			;        
			bcf		STATUS,RP0		;   0
;============================================================================================
;============================================================================================
		;      
			movlw	.0				; 
			call	big_str			;   CH-25xx
			call 	och_left		;  
;============================================================================================
			;==============			;		
			bsf		IZM				; 
			call	HIH				; 
			;==============			;
			;==============			;		
			bsf		IZM				; 
			call	HIH				; 
			;==============			;
			;==============			;		
			bsf		IZM				; 
			call	HIH				; 
			;==============			;
			;==============			;		
			bsf		IZM				; 
			call	HIH				; 
			;==============			;
;============================================================================================
;============================================================================================
;   
ind
			;==============			;
			btfsc	ERROR_D			
		goto	gotg
			btfss	RELE1			;   
			goto	$+3				;   
			bsf		TOCHm2			;
			goto	$+.2			;
			bcf		TOCHm2			;
			bsf		TOCHKA2			;
			;==============			;
gotg			clrwdt					;   ++++++
			;==============			;		
			call	HIH				;
			;==============			; 
		;	movlw	.120			;
		;	movwf	b_zad_ind		;
		;	call	ind_zad			;
			;==============			;
			call	upravl			;    (/)
			;==============			;
			call	klava			; 
;--------------------------------------------				
kontr		btfss	UST				;   
			goto	ind				;    / 
;--------------------------------------------
;   
nast	
			clrwdt					;   ++++++
			btfsc	kl_no			; 
			goto	$+4				; 
			movlw	.120			;   
			movwf	uskor			; 
		goto	ust_ind				; 
			movlw	.10
			subwf	uskor,w			;     1
			SKPNZ					; 
		goto	$+2					; 
			decf	uskor,f			; 
ust_ind			
			movfw	uskor			;
			movwf	b_zad_ind		;			
			call	ind_zad			; 			
			call	klava			; 
			call	upravl			; 
		goto	kontr				; 
;============================================================================================
;============================================================================================




;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================
;============================================================================================

;============================================================================================

;============================================================================================
kondosdata			;   
;		;   
			movf	Hi_zad_lo,w			;
			movwf	peAsl				;     	
			movf	Hi_zad_hi,w			;
			movwf	peAsh				;			
			movlw	Tmax_lo				;+ 100
			movwf	peBsl				;  
			movlw	Tmax_hi				; 
			movwf	peBsh				;  
			call    sravnenie			;
			btfsc	BOL					;   
			goto	vos_data			;

			movf	Hi_zad_lo,w			;
			movwf	peAsl				;     	
			movf	Hi_zad_hi,w			;
			movwf	peAsh				;			
			movlw	.0					;
			movwf	peBsl				;  
			movlw	.0					; 
			movwf	peBsh				;  
			call    sravnenie			;
			btfsc	MEN					;   
			goto	vos_data			;
;		;      
			movf	Gis_lo,w			;
			movwf	peAsl				;     	
			clrf	peAsh				;			
			movlw	G_MAX				;+ 25,0
			movwf	peBsl				;  
			clrf	peBsh				;  
			call    sravnenie			;
			btfsc	BOL					;   
			goto	vos_data			;
;		;  k1_lo
			movf	k1_lo,w				;
			movwf	peAsl				;     	
			movf	k1_hi,w				;			
			movwf	peAsh				; 
			movlw	0x03				;1000
			movwf	peBsh				;
			movlw	0xe8				;
			movwf	peBsl				;
			call    sravnenie			;
			btfsc	BOL					;   
			goto	vos_data			;
;		;  k2_lo
			movf	k2_lo,w				;
			movwf	peAsl				;     	
			movf	k2_hi,w				;			
			movwf	peAsh				; 
			movlw	0x27				;10000
			movwf	peBsh				;
			movlw	0x10				;
			movwf	peBsl				;
			call    sravnenie			;
			btfsc	BOL					;    
			goto	vos_data			;
;		;  k3_lo
			movf	k3_lo,w				;
			movwf	peAsl				;     	
			movf	k3_hi,w				;			
			movwf	peAsh				; 
			movlw	0x27				;10000
			movwf	peBsh				;
			movlw	0x10				;
			movwf	peBsl				;
			call    sravnenie			;
			btfsc	BOL					;    
			goto	vos_data			;

	return	
;
vos_data	
			;         EEPROM
			
			BANKSEL	TRISB				;  TRISB
			clrf	TRISB				;        
			BANKSEL	PORTB				; 
	
			clrf	flag_0				; 
			
			movlw	0x01				;			
			movwf	Hi_zad_hi			;* 
			movlw	0xf4				;
			movwf	Hi_zad_lo			;*

			movlw	.10					; 10.0	
			movwf	Gis_lo				;
			
			clrf	k1_hi				;*   1 (161)
			movlw	0xa2				;
			movwf	k1_lo				;*
			
			movlw	0x0b				;			
			movwf	k2_hi				;*   2 (2920)
			movlw	0x68				;
			movwf	k2_lo				;*

			movlw	0x13				;			
			movwf	k3_hi				;*   2 (2924)
			movlw	0x9c				;
			movwf	k3_lo				;*
			
			call	zap_eeprom			;      
alr_d
			
			bcf		RELE1			;   
			bcf		RELE2			;   		
			bcf		TOCHKA3			;   3
			bcf		TOCHKA2			;   3
			bcf		TOCHKA1			;   3			
			
			movlw	.40				; 
			call	big_str			;   

			goto	alr_d
;============================================================================================
;============================================================================================
upravl									;   
;============================================================================================
;============================================================================================
;=======================================  
			btfss	ON_OFF			;    ON_OFF
		goto	upr_na
			bcf		RELE1			;   
			bcf		RELE2			;   
		return						; 		
upr_na		btfsc	ERROR_D			;
		return
			btfss	STAR_IN
		return
;=======================================
			call	kondosdata 			;   				
;=======================================
			clrf	peBsh				; 
			movf	H_izm_lo,w			;
			movwf	peAsl				;     	
			movf	H_izm_hi,w			;
			movwf	peAsh				;			
			movf	Gis_lo,w			;      
			addwf	Hi_zad_lo,w			;
			movwf	peBsl				;  
			btfsc	STATUS,C			; 
			incf	peBsh,f				; 
			movf	Hi_zad_hi,w			;
			addwf	peBsh,f				;  
 			call    sravnenie			;
			btfsc	BOL_RAV				;      
			goto	off_re				;
				
			clrf	peBsh				; 
			movf	H_izm_lo,w			;
			movwf	peAsl				;     	
			movf	H_izm_hi,w			;
			movwf	peAsh				;			
			movf	Hi_zad_hi,w			;
			movwf	peBsh				;  			
			movf	Gis_lo,w			;      
			subwf	Hi_zad_lo,w			;
			movwf	peBsl				;  
			btfss	STATUS,C			; 
			decf	peBsh,f				; 
 			call    sravnenie			;
			btfss	MEN_RAV				;      
		goto		end_regre			;
			btfsc	UV_OS				;
		goto	off_re1	
onn_re1		bcf		RELE1				; ;
		goto		end_regre			;
off_re		btfsc	UV_OS				;		
		goto	onn_re1					;
off_re1		bsf		RELE1				; 
end_regre								; 
	return								; 
;============================================================================================

;============================================================================================
klava		;    

			bsf		STATUS,RP0		;   1
			movlw	PORTKN			;      
			movwf	TRISB				; 
			movlw	b'10001111'			;      
			movwf	TRISA				;
			bcf		STATUS,RP0		;   0
			goto	$+1					;  
			goto	$+1					;      
			goto	$+1					; 
			goto	$+1					; 
			goto	$+1					; 
			bcf		kl_no				;    
			
;======================   
			btfsc	RB_2				; 
		goto	k_U						; 
			btfss	vp_rp				;    
			goto	$+3					; 	
			bcf		vp_rp				;    
			goto	$+2					; 
			bsf		vp_rp				;    
			bsf		kl_no				;   			
			call	vybor_reg			;  
		goto	end_klava				; 			
;======================
k_U			btfsc	RB_3				; 
		goto	k_D						; 
			btfsc	vp_rp				;    		
		goto	tesvp					;	
			bsf		KL_U				;
			bcf		KL_D				;
		goto	tesvp					;			 
;======================			
k_D			btfsc	RB_4				; 
		goto	end_klava				;
			btfsc	vp_rp				;    	
			goto	tesvp				;	
			bsf		KL_D				;
			bcf		KL_U				;
;======================	
tesvp		btfss	vp_rp			;    
			goto	$+3				;
			call	ustanov			;  
		goto	end_klava			; 			
			call	vybor_reg		;  
end_klava


			bsf		STATUS,RP0			;   1
			clrf	TRISB				;        
			movlw	b'00000001'		;    A   R0  ,   
			movwf	TRISA			;
			bcf		STATUS,RP0			;   0

	return												
;============================================================================================
;============================================================================================						
vybor_reg
			bsf		STATUS,RP0			;   1
			clrf	TRISB				;        
			movlw	b'00000001'		;    A   R0  ,   
			movwf	TRISA			;
			bcf		STATUS,RP0			;   0

;			bcf		RAKTD			;   
;			bcf		RELE2			;   
			bsf		kl_no			;   

			bcf		TOCHKA1			;   	  
			bcf		TOCHKA2			;   	  				
			bcf		TOCHKA3			;   	  	
			bsf		UST				; 
			movlw	DIND			;   
			movwf	avtovyh			; 

			btfss	vp_rp			;     
			goto	pr_pr			;    			
			btfsc	ONF				; 
			goto	ONF_f			; 
			btfsc	TUM				; 
			goto	TUM_f			; 			
			btfsc	UGZ				; 
			goto	UGZ_f			; 			
			btfsc	TDO				; 
			goto	TDO_f			; 			
			btfsc	KK1				; 
			goto	KK1_f			; 
			btfsc	KK2				; 
			goto	KK2_f			; 
			btfsc	KK3				; 
			goto	KK3_f			; 			
			btfsc	IZG				; 
			goto	IZG_f			; 			
			goto	ONF_f			; 						
pr_pr			
			btfsc		KL_U		;
		goto	prev		 
next		btfsc	ONF				;   
			goto	TUM_f			; 
			btfsc	TUM				; 
			goto	UGZ_f			; 
			btfsc	UGZ				; 
			goto	TDO_f			; 
			btfsc	TDO				; 
			goto	KK1_f			; 
			btfsc	KK1				; 
			goto	KK2_f			; 
			btfsc	KK2				; 
			goto	KK3_f			; 
			btfsc	KK3				; 
			goto	IZG_f			; 			
			goto	ONF_f			;   


prev		btfsc	ONF				;   
		goto	IZG_f			; 
			btfsc	IZG				; 
		goto	KK3_f			; 
			btfsc	KK3				; 
		goto	KK2_f			; 
			btfsc	KK2				; 
		goto	KK1_f			; 
			btfsc	KK1				; 
		goto	TDO_f			; 
			btfsc	TDO				; 
		goto	UGZ_f			; 
			btfsc	UGZ				; 
		goto	TUM_f			; 			
		goto	ONF_f			;   
;===============================================
	;  
IZG_f		movlw	b'10000000'		; 
			movwf	flag_2			;      (10-60)
			btfsc	vp_rp			;     
		goto	IZG_d				;    
			movlw	.85				; . 
		goto	end_big				; 
IZG_d		movlw	.24				; . 
			call	big_str			;   
			movlw	.85				; . 
			call	big_str			;   	
		goto	end_vybor			; 
;===============================================
;===============================================
		;    3
KK3_f		movlw	b'01000000'
			movwf	flag_2			;   
			btfsc	vp_rp			;     
		goto	KK3_d				;    
			movlw	.97				; tuc
		goto	end_big				; 
KK3_d		
			movfw	k3_hi			; 
			movwf	binh			; 
			movfw	k3_lo			; 
			movwf	binl			; 
		goto	infk3				; 
;===============================================
;===============================================
		;    2
KK2_f		movlw	b'00100000'
			movwf	flag_2			;   
			btfsc	vp_rp			;     
		goto	KK2_d				;    
			movlw	.93				; tuc
		goto	end_big				; 
KK2_d		
			movfw	k2_hi			; 
			movwf	binh			; 
			movfw	k2_lo			; 
			movwf	binl			; 

infk3		bcf		TOCHKA2			;
			call    bin_dec			; 
			movfw	dest			; 
			movwf	ind_3			; 
			movfw	sotn			; 
			movwf	ind_2			; 
			movfw	tysc			; 
			movwf	ind_1			; 
		 goto	end_vybor			; 
;===============================================
;===============================================
		;    1
KK1_f		movlw	b'00010000'
			movwf	flag_2			;   
			btfsc	vp_rp			;     
		goto	KK1_d				;    
			movlw	.81				; tuc
		goto	end_big				; 
KK1_d		
			movfw	k1_hi			; 
			movwf	binh			; 
			movfw	k1_lo			; 
			movwf	binl			; 
			bcf		TOCHKA2			;
			call    bin_dec			; 
			call	p_kl2			; 
		goto	end_vybor			; 
;===============================================
;===============================================
	;   /	 
TDO_f		movlw	b'00001000'		; 
			movwf	flag_2			;       
			btfsc	vp_rp			;     
		goto	TDO_d				;    
			movlw	.77				; dot
		goto	end_big				;  
TDO_d		btfsc	UV_OS			; 
			goto	TDOoff			; 
			movlw	b'10000000'		;  -
			movwf	ind_1			;
			movlw	b'10111000'		;  o
			movwf	ind_2			;			
			movlw	b'10000000'		;  -
			movwf	ind_3			;
			goto	end_vybor		; 
TDOoff		movlw	b'10000000'		;  -
			movwf	ind_1			;
			movlw	b'01111100'		;  U
			movwf	ind_2			;
			movlw	b'10000000'		;  -
			movwf	ind_3			;
		goto	end_vybor			; 
;===============================================
	; 
UGZ_f		movlw	b'00000100'		; 
			movwf	flag_2			;   
			btfsc	vp_rp			;     
		goto	UGZ_d				;    
			movlw	.73				; qic
		goto	end_big				;  
UGZ_d		movfw	Gis_lo			; 
			movwf	binl			; 
			clrf	binh			; 
 		goto	end_vybor1			; 
;===============================================
		;   
TUM_f		movlw	b'00000010'		; 
			movwf	flag_2			;   
			btfsc	vp_rp			;     
		goto	TUM_d				;    
			movlw	.69				; tuc
		goto	end_big				; 
TUM_d								; 
			movfw	Hi_zad_hi		; 
			movwf	binh			; 
			movfw	Hi_zad_lo		; 
			movwf	binl			; 
		goto	end_vybor1			; 
;===============================================
ONF_f		movlw	b'00000001'		; 
			movwf	flag_2			;    . .
			btfsc	vp_rp			;     
		goto	ONF_d				;    
			movlw	.89				; 		
		goto	end_big				; 
ONF_d		btfsc	ON_OFF			; 
			goto	ioff			; 
			clrf	ind_1			;
			movlw	b'10111000'		;  o
			movwf	ind_2			;			
			movlw	b'10101000'		;  n
			movwf	ind_3			;
			goto	end_vybor		; 
ioff		movlw	b'10111000'		;  o
			movwf	ind_1			;
			movlw	b'11100010'		;  F
			movwf	ind_2			;
			movlw	b'11100010'		;  F
			movwf	ind_3			;
		goto	end_vybor			; 
end_big								; 
			btfsc	KL_D			; 
			call	big_str			;   
			btfsc	KL_U			; 
			call	big_str_re		;   
		goto	end_vybor			; 
end_vybor1							; 
			bsf		BTE				; 
			call    bin_dec			; 
			call	p_ind_r			; 
end_vybor							; 
			bcf		KL_F			; 
			bsf		STATUS,RP0		;   1
			clrf	TRISB			;        
			bcf		STATUS,RP0		;   0
	return							; 
;============================================================================================
;============================================================================================
;============================================================================================
ustanov	

			bsf		kl_no			;   
	
			movlw	DIND			;   
			movwf	avtovyh			;   

			btfsc	TUM				; 
			goto	u_TUM			; 
			btfsc	UGZ				; 
			goto	u_UGZ			; 
			btfsc	TDO				; 
			goto	u_TDO			; 
			btfsc	ONF				; 
			goto	u_ONF			;
			btfsc	KK1				; 
			goto	u_KK1			; 
			btfsc	KK2				; 
			goto	u_KK2			; 
			btfsc	KK3				; 
			goto	u_KK3			; 
	return			 
;=========================================
u_KK3	;------------------------------------------------------
;=========================================
			;  3
			btfsc	RB_4				; + 
		goto	kk_KK3					;
			movlw	0x27				; 
			movwf	peAsh				; 
			movlw	0x06				;
			movwf	peAsl				;		
			movf	k3_hi,w				;
			movwf	peBsh				;
			movf	k3_lo,w				;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	kk_KK3					;
			movlw	.10					;
			addwf	k3_lo,f				;
			btfsc	STATUS,C			;
			incf	k3_hi,f				;
	goto	end_KK3						; 
kk_KK3									; 
			btfsc	RB_3				; - 
	goto	end_KK3						; 
			clrf	peAsh				;       			
			clrf	peAsl				;
		;	movf	k3_hi,w				;
		;	movwf	peBsh				;
		;	movf	k3_lo,w				;
		;	movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
	goto	end_KK3						; 
			movlw	.10					;
			subwf	k3_lo,f				;
			btfss	STATUS,C			;
			decf	k3_hi,f				;
end_KK3									;
	goto	KK3_d						;
;=========================================
u_KK2	;------------------------------------------------------
;=========================================
			;  2
			btfsc	RB_4				; + 
		goto	kk_KK2					;
			movlw	0x27				; 
			movwf	peAsh				; 
			movlw	0x06				;
			movwf	peAsl				;		
			movf	k2_hi,w				;
			movwf	peBsh				;
			movf	k2_lo,w				;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	kk_KK2					;
			movlw	.10					;
			addwf	k2_lo,f				;
			btfsc	STATUS,C			;
			incf	k2_hi,f				;
	goto	end_KK2						; 
kk_KK2									; 
			btfsc	RB_3				; - 
	goto	end_KK2						; 
			clrf	peAsh				;       			
			clrf	peAsl				;
		;	movf	k2_hi,w				;
		;	movwf	peBsh				;
		;	movf	k2_lo,w				;
		;	movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
	goto	end_KK2						; 
			movlw	.10					;
			subwf	k2_lo,f				;
			btfss	STATUS,C			;
			decf	k2_hi,f				;
end_KK2									;
	goto	KK2_d						;
;=========================================
u_KK1	;------------------------------------------------------
;=========================================
			;  1
			btfsc	RB_4				; + 
		goto	kk_KK1					;
			movlw	0x03				; 
			movwf	peAsh				; 
			movlw	0xE7				;
			movwf	peAsl				;		
			movf	k1_hi,w				;
			movwf	peBsh				;
			movf	k1_lo,w				;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	kk_KK1					;
			movlw	.1					;
			addwf	k1_lo,f				;
			btfsc	STATUS,C			;
			incf	k1_hi,f				;
	goto	end_KK1						; 
kk_KK1									; 
			btfsc	RB_3				; - 
	goto	end_KK1						; 
			clrf	peAsh				;       			
			clrf	peAsl				;
		;	movf	k1_hi,w				;
		;	movwf	peBsh				;
		;	movf	k1_lo,w				;
		;	movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
	goto	end_KK1						; 
			movlw	.1					;
			subwf	k1_lo,f				;
			btfss	STATUS,C			;
			decf	k1_hi,f				;
end_KK1									;
	goto	KK1_d						;
;=========================================

u_TUM	;------------------------------------------------------
;====================================
			;  
			btfsc	RB_4					; + 
		goto	kk_TEMP					;
			movlw	Tmax_hi				;       
			movwf	peAsh				;_-2-5.
			movlw	Tmax_lo				;
			movwf	peAsl				;		
			movlw	.10					;
			subwf	peAsl,f				;			
			BC		$+2					;			
			decf	peAsh,f				;
			movfw	Gis_lo				;
			subwf	peAsl,f				;
			BC		$+2					;			
			decf	peAsh,f				;

			movf	Hi_zad_hi,w			;
			movwf	peBsh				;
			movf	Hi_zad_lo,w			;
			movwf	peBsl				;
			call	sravnenie			;
			btfss	BOL					;
		goto	kk_TEMP					;
			movlw	.1					;
			addwf	Hi_zad_lo,f			;
			btfsc	STATUS,C			;
			incf	Hi_zad_hi,f			;
	goto	end_TEMP					; 

kk_TEMP									; 
			btfsc	RB_3					; - 
	goto	end_TEMP					; 
			clrf	peAsh				;       			
			movlw	.10					; 
			movwf	peAsl				;  + 5  + 1+2
			movlw	Tmin_lo				;
			addwf	peAsl,f				;
			BNC		$+2					;
			incf	peAsh,f				;
			movfw	Gis_lo				;
			addwf	peAsl,f				;
			BNC		$+2					;
			incf	peAsh,f				;			
			movlw	Tmin_hi				;
			addwf	peAsh,f				;
		;	movf	Hi_zad_hi,w
		;	movwf	peBsh				;
		;	movf	Hi_zad_lo,w
		;	movwf	peBsl				;
			call	sravnenie			;
			btfss	MEN					;
	goto	end_TEMP					; 
			movlw	.1					;
			subwf	Hi_zad_lo,f			;
			btfss	STATUS,C			;
			decf	Hi_zad_hi,f			;
end_TEMP
	goto	TUM_d

u_UGZ	;------------------------------------------------------
			btfsc	RB_4			; 
			goto	u_U_U			;
			
			movlw	G_MAX			;    
			subwf	Gis_lo,w		;
			BZ	end_gis				;	
			movlw	.1				;
			addwf	Gis_lo,f		;
			goto	end_gis			;
			
u_U_U		btfsc	RB_3			; 
			goto	end_gis			;
			movlw	G_MIN			;
			subwf	Gis_lo,w		;
			BZ	end_gis				;
			movlw	.1				;
			subwf	Gis_lo,f		;
end_gis			
	goto	UGZ_d
u_TDO	;------------------------------------------------------
			btfsc	RB_3			; 
			goto	$+2				;
			bsf		UV_OS			;	
			
			btfsc	RB_4			; 
			goto	$+2				;
			bcf		UV_OS			;
	goto	TDO_d
u_ONF	;------------------------------------------------------						
			btfsc	RB_3			; 
			goto	$+2				;
			bsf		ON_OFF			;	
			
			btfsc	RB_4			; 
			goto	$+2				;
			bcf		ON_OFF			;		
	goto	ONF_d
;============================================================================================
;============================================================================================						

;********************  ************************************************
mig_u								;   

	;		movlw	.150			;
	;		movwf	b_zad_ind		;
	;		call	ind_zad			;
			
			btfsc	B_MIG
			goto	$-1
		bsf		RAZR1				;    
		bsf		RAZR2				; 0 -  
		bsf		RAZR3				; 1 -    2 .
			;==============			; 
			movlw	.255			;
			movwf	b_zad_ind		;			
			call	ind_zad			;
			movlw	.255			;
			movwf	b_zad_ind		;			
			call	ind_zad			;
			movlw	.255			;
			movwf	b_zad_ind		;			
			call	ind_zad			;
			;==============			;
		btfsc	B_MIG
		goto	$-1
		bcf		RAZR1				;    
		bcf		RAZR2				; 0 -  
		bcf		RAZR3				; 1 -    2 .
			movlw	.255			;
			movwf	b_zad_ind		;
			call	ind_zad			;
	return

;********************   *************************************************************
									;   
ind_zad								;
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.60				;
			movwf	b_zad_ind		;
		return						; 					; 
;============================================================================================
big_str								;   
			movwf	temp2			; 		
			bcf		TOCHKA1			;   				
			bcf		TOCHKA2			;   				
			bcf		TOCHKA3			;   
			call 	och_left		;  
			movfw	temp2			;   
			movwf	schet_sim2		; 
			call 	text_1			;  
			movwf 	schet_sim1		;      
infch		incf	schet_sim2,f	;    
			decfsz	schet_sim1,f	;  .   1    0
			goto	pr				;  
	return
pr			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			movfw	schet_sim2		;    
			call 	text_1			;   
			movwf	ind_3			;   
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	infch			;  
;============================================================================================
big_str_re							;       
			movwf	temp2			; 		
			bcf		TOCHKA1			;   				
			bcf		TOCHKA2			;   				
			bcf		TOCHKA3			;   
			call 	och_ring		;  
			movfw	temp2			;   
			movwf	schet_sim2		; 
			call 	text_1			;  
			movwf 	schet_sim1		;      
			;movfw	temp2
			addwf	schet_sim2,f
infch_re	decf	schet_sim2,f	;    
			decfsz	schet_sim1,f	;  .   1    0
			goto	pr_re			; 	 
			;call 	och_ring		;  
	return
pr_re		clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			movfw	schet_sim2		;    
			call 	text_1			;   
			movwf	ind_1			;   
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	infch_re		; 	 
;============================================================================================
			;   "<-"
och_left	movlw	.4				;    +1
			movwf	schet_sim2		;   
dec_left	decfsz	schet_sim2,f	;  .   1    0
			goto	$+.2			; 	 
		return						; 	 
			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			clrf	ind_3			;  3 
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	dec_left		; 	 
;============================================================================================
			;   "->"
och_ring	movlw	.4				;    +1
			movwf	schet_sim2		;   
dec_ring	decfsz	schet_sim2,f	;  .   1    0
			goto	$+.2			; 	 
		return						; 	 
			clrwdt					;   ++++++
			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			clrf	ind_1			;  3 
			clrwdt					;   ++++++
			movf	b_zad_ind,f		;	
			BNZ		$-3				;
			movlw	.65				;
			movwf	b_zad_ind		;
			goto	dec_ring		; 	 
;********************   *************************************************************
c_ind 		clrwdt					;   ++++++
			movlw	.60
			movwf	b_zad_ind
			call	ind_zad			;  
	return
;============================================================================================
;============================================================================================	
;===================================================================================
;   / 	
;============================================================================================
indic								;   
;=============================================	
			btfsc	TOCHKA1			;   
			bsf		ind_1,0			; 
			btfsc	TOCHKA2			; 
			bsf		ind_2,0			; 
			btfsc	TOCHKA3			; 
			bsf		ind_3,0			; 
;=============================================	
;=============================================	
i1ry		btfss	reg_ind,0		; 
		goto	i2ry				; 
;=========================			; 
			movlw	b'00000010'		;  
			movwf	reg_ind			; 
;=========================			; 
			movfw	ind_1			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR1			; 
			goto	ir1t			;   
;=========================			; 
			btfss	B_MIG			; 
			goto	ir1t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
;=========================			; 	
ir1t		btfss	TOCHm1			; 
			goto	ir1				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir1			goto	indiprot		; 
;=============================================	
;=============================================		
i2ry		btfss	reg_ind,1		; 
		goto	i3ry				; 
;=========================			; 
			movlw	b'00000100'		;   
			movwf	reg_ind			; 
;=========================			; 
			movfw	ind_2			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR2			; 
			goto	ir2t			;   
;=============================================		
			btfss	B_MIG			; 
			goto	ir2t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
;=========================			; 		
ir2t		btfss	TOCHm2			; 
			goto	ir2				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir2			goto	indiprot		; 
;=============================================	
;=============================================	
i3ry								; 
			movlw	b'00000001'		;   
			movwf	reg_ind			; 
;=========================			; 
			movfw	ind_3			;      ()
			movwf	r_PORTB			;   
			btfss	RAZR3			; 
			goto	ir3t			;   
;=============================================		
			btfss	B_MIG			; 
			goto	ir3t			;   0  
			movlw	b'00000001'		; 
			andwf	r_PORTB,f		;   1  
;=========================			; 		
ir3t		btfss	TOCHm3			; 
			goto	ir3				;   
;=========================			; 
			btfss	B_MIG			;  
			bcf		r_PORTB,0		;   0  
;=========================			; 
ir3	;		goto	indiprot		;
;=============================================	
;=============================================	
indiprot	;     				
			;   c     ()			
			movfw	PORTB			;  
			movwf	d_PORTB			; 
			movfw	PORTA			; 
			movwf	d_PORTA			; 
;====================================
			movlw	CL_PA			;   A (c  RA4/3   )  
			andwf	d_PORTA,f		;			
			movlw	SE_PA			;      off
			iorwf	d_PORTA,f		; 

			movlw	CL_PB			;   A (c  RA4   )  
			andwf	d_PORTB,f		;			
			movlw	SE_PB			;      off
			iorwf	d_PORTB,f		; 
;====================================			
			movfw	d_PORTA			;  
			movwf	PORTA			; 
			movfw	d_PORTB			; 
			movwf	PORTB			;   
;====================================
			
			btfsc	r_PORTB,0		;  
			bcf		S_H				;   
			btfsc	r_PORTB,1		;
			bcf		S_A				;			
			btfsc	r_PORTB,2		;
			bcf		S_B				;
			btfsc	r_PORTB,3		;
			bcf		S_C				;
			btfsc	r_PORTB,4		;
			bcf		S_D				;
			btfsc	r_PORTB,5		;
			bcf		S_E				;
			btfsc	r_PORTB,6		;
			bcf		S_F				;
			btfsc	r_PORTB,7		;
			bcf		S_G				;			

			btfsc	reg_ind,1		;   
			bsf		SOT				;  
			btfsc	reg_ind,2		; 
			bsf		DES				; 
			btfsc	reg_ind,0		; 
			bsf		EDI				; 
;=====================================
			btfsc	RELE1			;   
		goto	$+3					; 
			bcf		d_PORTB,0		; 
		goto	$+2					; 
			bsf		d_PORTB,0		; 			
;=====================================			
;			btfsc	RELE2			;   
;		goto	$+3					; 
;			bcf		d_PORTA,0		; 
;		goto	$+2					; 
;			bsf		d_PORTA,0		; 			
;=====================================			
;			btfsc	RELE3			;   
;		goto	$+3					; 
;			bcf		d_PORTA,4		; 
;		goto	$+2					; 
;			bsf		d_PORTA,4		; 
;=====================================
			movfw	d_PORTA			;  
			movwf	PORTA			; 
			movfw	d_PORTB			; 
			movwf	PORTB			; 
	return							; 
;============================================================================================

;============================================================================================
;======================== ================================================
vost_data								; 
			movlw	(end_stek-flag_0)+1	; 
			movwf	chtteep				; 
			movlw	flag_0				; 
			movwf	FSR					;     
			clrf	adr_e				; 			
povch			
			call	prov_eep			;    EEPROM
			movwf	INDF				;      
			incf	FSR,f			
			incf	adr_e,f				;   EEPROM
			decfsz	chtteep,f			;      
			goto	povch				;    
	return								; 
;============================================================================================
;============================================================================================
prov_eep	call	rd_eeprom			;  
			movf	data_e,w			; 
			movwf	temp1				; 
			incf	adr_e,f				;   EEPROM
			call	rd_eeprom			;   ()
			movf	data_e,w			;
			subwf	temp1,w			;      EEPROM
			btfss	STATUS,Z			; 
			goto	$+3					; 
			movf	data_e,w			;  
		return							; 
			btfss	STATUS,C			; 
			goto	$+3					; 
			movf	data_e,w			; 
			goto	$+2					; 
			movf	temp1,w			; 
			bsf		E_data				;   EEPROM
		return							; 
;=================================================================================================
rd_eeprom	movfw	adr_e				;    
			bsf		STATUS,RP1			;   2
			movwf	EEADR				;   
			bsf		STATUS,RP0			;   3 
			BCF 	EECON1,EEPGD		;    (EEPROM)		
			bsf		EECON1,RD			;     EEPROM
			bcf		STATUS,RP0			;   2 
			movfw	EEDATA				;    
			bcf		STATUS,RP1			;   0
			movwf	data_e				;   
	return
;=================================================================================================
zap_eeprom								;   EEPROM
			movf	INTCON,w
			movwf	perem5				;    INTCON			
			bcf		INTCON,GIE			;   			

			movlw	(end_stek-flag_0)+1	;       Tzad_h1  kol_oh_vv	
			movwf	chtteep				; 
			movlw	flag_0
			movwf	FSR					;    
			clrf	adr_e				; 			
povch1		
			movf	INDF,w				;      
			call	zap_2byt_eeprom		;
			incf	FSR,f
			incf	adr_e,f				;   EEPROM
			decfsz	chtteep,f				;      
			goto	povch1				;    
			
;				   EEPROM
stop_wr_e		
			BANKSEL	EECON1
			btfsc	EECON1,WR		;      EEPROM
			goto	$-1
			bcf		EECON1,WREN		;  			
			bcf		STATUS,RP0		;   0
			bcf		STATUS,RP1		;   0
			
			movf	perem5,w
			movwf	INTCON				;    INTCON
	return								;
;********************************************************************************************
zap_2byt_eeprom							;
			movwf	data_e				;
			movwf	temp2				;
			call	wr_eeprom			;
			incf	adr_e,f				;    EEPROM 
			movf	temp2,w			;
			movwf	data_e				;
			call	wr_eeprom			;
	return								;
;===========================================================================================				
;===========================================================================================				
;				   EEPROM
wr_eeprom		
			BANKSEL	EECON1
			btfsc	EECON1,WR		;      EEPROM
		goto	$-1					; 
			BCF 	EECON1,EEPGD	; Point to DATA	memory
			bsf		EECON1,WREN		;  
			BANKSEL	adr_e			; 
			movfw	adr_e			; 
			bsf		STATUS,RP1		;   2			
			movwf	EEADR			;   1
			bcf		STATUS,RP1		;   0 
			movfw	data_e			;      
			bsf		STATUS,RP1		;   2 
			movwf	EEDATA			;  EEPROM
			bsf		STATUS,RP0		;   3 
			movlw	0x55			;     EEPROM
			movwf	EECON2			;
			movlw	0xAA			;
			movwf	EECON2			;
			bsf		EECON1,WR		;  
;			btfsc	EECON1,WR		;      EEPROM
;		goto	$-1	
			bcf		STATUS,RP0		;   0
			bcf		STATUS,RP1		;   0
	return
;===========================================================================================
;===========================================================================================

;===========================================================================================
;===========================================================================================
zam_left
			;        "<-"

			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_1
			movwf	ind_3			;  3 
			call	c_ind			;  
			clrwdt					;   ++++++

			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_2
			movwf	ind_3			;  3 
			call	c_ind			;  
			clrwdt					;   ++++++
			
			movfw	ind_2			;  2   1 
			movwf	ind_1			;   
			movfw	ind_3			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_3
			movwf	ind_3			;  3 
			call	c_ind			;  
			clrwdt					;   ++++++
	return
;===========================================================================================
zam_ring
			;        "->"

			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_3
			movwf	ind_1			;  1 
			call	c_ind			;  
			clrwdt					;   ++++++

			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_2
			movwf	ind_1			;  1 
			call	c_ind			;  
			clrwdt					;   ++++++
			
			movfw	ind_2			;  2   1 
			movwf	ind_3			;   
			movfw	ind_1			;  3   2 
			movwf	ind_2			;   
			movfw	buf_ind_1
			movwf	ind_1			;  1 
			call	c_ind			;  
			clrwdt					;   ++++++
	return

;===========================================================================================
;===========================================================================================
HIH												;   		
				btfss	IZM						;    
		return									;
				bcf		IZM

				bsf		IZM_ACP					;  
				btfsc	IZM_ACP					;    
				goto	$-1						;


				banksel ADRESL
				movf	ADRESL,w
				banksel fssl				
				movwf	fssl
				movf	ADRESH,w
				movwf	fssh	

			call	average

				
				
				
	;			movlw	0x12
	;		movwf	SIN_lo
	;			movlw	0x01
	;		movwf	SIN_hi			
			;	movlw	0xB4					;  0,884/0,004882813=181 	
			;	movlw	0x9f					; 0.811/0,00498046875 =162;0,005078125/
				movfw	k1_lo					; 
				subwf	SIN_lo,f				;      
				BC		$+2						; 
				decf	SIN_hi,f				; 
				movfw	k1_hi					; 
				subwf	SIN_hi,f				; 
				
				;  
				clrf	peAsu					; 
				movfw	SIN_hi					; 			
				movwf	peAsh					; 
				movfw	SIN_lo					; 			
				movwf	peAsl					; 			
				clrf	peBsu					; 
		
				movfw	k3_hi					; 			
				movwf	peBsh					; 
				movfw	k3_lo					; 			
				movwf	peBsl					; 			
				call	D_mpyS					; 
	
				movfw	peBsl					; 			
				movwf	peAsu					; 
				movfw	peCsh					; 			
				movwf	peAsh					; 
				movfw	peCsl					; 			
				movwf	peAsl					; 
				clrf	peBsu					; 
				
				movfw	k2_hi					; (0x0C;0x6c   0,0318 * 100 000 = 3 180) 2920			
				movwf	peBsh					; 
				movfw	k2_lo					; 
				movwf	peBsl					; 
				call	FXD2424U				; 
;================================				
;    
				movfw	peAsh					;  			
				xorwf 	H_p_hi					; 
				btfss	STATUS,Z
			goto	conv_tn
				movfw	peAsl					; 			
				xorwf 	H_p_lo					;
 				btfsc	STATUS,Z
			goto	conv_ts
conv_tn
				movfw	peAsh					;  			
				movwf	H_p_hi					;
				movfw	peAsl					; 			
				movwf	H_p_lo					;
			goto	conv_t
conv_ts
				decfsz	timcon,f
			goto	conv_t
;================================
				movfw	peAsh					; 			
				movwf	binh					; 
				movwf	H_izm_hi				; 				
				movfw	peAsl					; 			
				movwf	binl					;
				movwf	H_izm_lo				; 
				
				call	bin_dec					;
				movfw	edin					;
				movwf	ind_3					;
				movfw	dest					;
				movwf	ind_2					;
				movfw	sotn					;
				movwf	ind_1					;
	
;===========================================================================================
conv_t								;   
			bcf		ERROR_D			;

			btfsc	H_izm_hi,7		;
		goto	Erro				;

			movf	binh,w			;   >100.0%
			movwf	peAsh			;			
			movf	binl,w			;
			movwf	peAsl			;
			movlw	0x03			;
			movwf	peBsh			;
			movlw	0xE8			;
			movwf	peBsl			;
			call    sravnenie		;
			btfsc	BOL				;
		goto	Erro
nam55			
			movf	binh,w			;   <1.0%
			movwf	peAsh			;			
			movf	binl,w			;
			movwf	peAsl			;
			movlw	0x00			;
			movwf	peBsh			;
			movlw	.10				;
			movwf	peBsl			;
			call    sravnenie		;
			btfss	MEN				;
		goto	p_ind_r				;
Erro			
			btfss	STAR_IN
		return
			bsf		ERROR_D
			bcf		RELE1			;   
			bcf		TOCHKA2			;
			movlw	b'11110010'		; 
			movwf	ind_1			; 
			movlw	b'10100000'		; 
			movwf	ind_2			;
			movwf	ind_3			;
		return							
p_ind_r
			;==============			;
			btfss	RELE1			;   
			goto	$+3				;   
			bsf		TOCHm2			;
			goto	$+.2			;
			bcf		TOCHm2			;
			bsf		TOCHKA2			;
			;==============			;
p_kl2			
			movfw	edin			; 
			movwf	ind_3			; 
			movfw	dest			; 
			movwf	ind_2			; 
			movfw	sotn			; 
			movwf	ind_1			; 				
		return						; 
;===========================================================================================

;===========================================================================================

sravnenie								;
			clrf	flag_srv			;   
			clrf	regsr				;    
			

sr16z		btfsc	peAsh,7				;  7   0 
			bsf		regsr,0				;  1 .  1  0 .
			btfsc	peBsh,7				;  7   0 
			bsf		regsr,1				;  1 .  1  1 .
										; 0   
										; 1  .
										; 2  
										; 3  .
						;   
						;   
			
uzs			movf	regsr,f				;
			BZ		srv					;        
			movlw	.1					; 
			subwf	regsr,w				;   5 = 1,  peAsh , ,  peBsh 
			BNZ		$+4					;
			bsf		MEN					;  peBsh>peAsh 
			bsf		MEN_RAV				;
		return							; 
			movlw	.2					;   5 = 2   peBsh , ,  peAsh 
			subwf	regsr,w				;
			BNZ		srv					;         
			bsf		BOL					;  peBsh<peAsh  
			bsf		BOL_RAV				;
		return							; 
	;===================================   
srv										;
			movf	peAsh,w				;   
			subwf	peBsh,w				;(  )
			btfss	STATUS,Z
			goto	$+2					;   
			goto	prs					;     
			movf	peAsh,w				; 
			subwf	peBsh,w				;   
			btfsc	STATUS,C			;
			goto	$+4					;
			bsf		BOL					; peAsh>peBsh    
			bsf		BOL_RAV				;
		return							; 
			bsf		MEN					; peAsh<peBsh     			
			bsf		MEN_RAV				;
		return							;
prs			movf	peAsl,w				;   
			subwf	peBsl,w				;(  )
			btfss	STATUS,Z
			goto	$+.5				;   
			bsf		RAV					; peAsh=peBsh  temp2=peBsh
			bsf		MEN_RAV				; 
			bsf		BOL_RAV				; 		
		return
			movf	peAsl,w				; 
			subwf	peBsl,w				;   
			btfsc	STATUS,C
			goto	$+4					;
			bsf		BOL					; peAsh=peBsh  temp2>
			bsf		BOL_RAV
		return							; 
			bsf		MEN					; peAsh=peBsh  temp2< 
			bsf		MEN_RAV				;
		return							;
;============================================================================================
;============================================================================================
;***  24/16      7    ****************
;    24   - - 8 388 607  + 8 388 607
;  16   - - 32767  + 32767
										;   binl, binh, binu
										;  edin,dest,sotn,tysc,dtys,stys,mlon
										; B24 0  16 , 1- 24 (16  )
										; BTE    00  0
										; BTE0_00	 " "    - 0,00
bin_dec
;===============================================
	;			movfw	binu			; 
	;			movwf	t_binu			; 
				movfw	binh			; 
				movwf	t_binh			; 
				movfw	binl			; 
				movwf	t_binl			; 
;===============================================							
				bcf		MINUS			;    
				btfsc	B24				;   
			goto	bi0p				; 
				clrf	binu			;      16  
				btfss	binh,7			;   			
				goto	bi0				; 
			goto	comfd				;
bi0p			btfss	binu,7			;   
			goto	bi0					; 
				comf	binu,f			;       	
comfd			bsf		MINUS			;     
				comf	binl,f			; 
				comf	binh,f			; 
				movlw	.1				; 
				addwf	binl,f			; 
			BNC		bi0					; 
				addwf	binh,f			; 
			BNC		bi0					; 
				incf	binu,f			; 
;===============================================
bi0				bcf		B24				;    24  
	 			bcf     STATUS,0        ; clear the carry bit
				movlw   .24				; 
				movwf   count			; 
				clrf    R3				; 
				clrf    R2				; 
				clrf    R1				; 
				clrf    R0				; 
loop24  		rlf     binl, F			; 
				rlf     binh, F			; 
				rlf     binu, F			; 
				rlf     R0, F			; 
				rlf     R1, F			; 
				rlf     R2, F			; 
				rlf     R3, F			; 
				decfsz  count, F		; 
			goto    adjDEC				; 
;===============================================
				movfw	R3				; 
				andlw	b'00001111'		; 
				movwf	mlon			; 
				swapf	R2,w			; 
				andlw	b'00001111'		; 
				movwf	stys			; 
				movfw	R2				; 
				andlw	b'00001111'		; 
				movwf	dtys			; 
				swapf	R1,w			; 
				andlw	b'00001111'		; 
				movwf	tysc			; 
				movfw	R1				; 
				andlw	b'00001111'		; 
				movwf	sotn			; 
				swapf	R0,w			; 
				andlw	b'00001111'		; 
				movwf	dest			; 
				movfw	R0				; 
				andlw	b'00001111'		; 
				movwf	edin			; 
;===============================================
		;    		
gnn				movlw	.10				;    ()
				movf	mlon,f			;   
				BNZ		preo01			;     
				movwf	mlon			;    
				
				movf	stys,f			;   
				BNZ		preo01			;     
				movwf	stys			;    
				
				movf	dtys,f			;   
				BNZ		preo01			;     
				movwf	dtys			;    
				
				movf	tysc,f			;   
				BNZ		preo01			;     
				movwf	tysc			;    	
				
				movf	sotn,f			;   
				BNZ		preo01			
				btfss	BTE0_00			;    0  00
			goto	tuns				;   0
				bcf		BTE0_00			;    
			goto	preo01				;   00				
tuns			movwf	sotn			;    	
				movf	dest,f			;   
				BNZ		preo01			; 
				btfss	BTE				;    0  00
			goto	tunn				;   0
				bcf		BTE				;    
			goto	preo01				;   00				
tunn			movwf	dest			;    				
;===============================================
preo01		;       
				btfss	MINUS			;
			goto 	concis				;
				movlw	.10				;      
				subwf	dest,w			; 
				btfss	STATUS,Z		;
				goto 	mt60			; 
				movlw	.11				;
				movwf	dest			;    
			goto 	concis				;
mt60			movlw	.10				;      
				subwf	sotn,w			; 
				btfss	STATUS,Z		;
				goto 	mt61			; 
				movlw	.11				;
				movwf	sotn			;    
			goto 	concis				;
mt61			movlw	.10				;      
				subwf	tysc,w			; 
				btfss	STATUS,Z		;
				goto 	mt62			; 
				movlw	.11				;
				movwf	tysc			;    
			goto 	concis				;
mt62			movlw	.10				;      
				subwf	dtys,w			; 
				btfss	STATUS,Z		;
				goto 	mt63			; 
				movlw	.11				;
				movwf	dtys			;    
			goto 	concis				;
mt63			movlw	.10				;      
				subwf	stys,w			; 
				btfss	STATUS,Z		;
				goto 	mt64			; 
				movlw	.11				;
				movwf	stys			;    
			goto 	concis				;
mt64			movlw	.11				;
				movwf	mlon			;    					
;===============================================
			;      
concis			movf	mlon,w			; 
				call 	deshif			; 
				movwf	mlon			;
				movf	stys,w			; 
				call 	deshif			; 
				movwf	stys			;			
				movf	dtys,w			; 
				call 	deshif			; 
				movwf	dtys			;
				movf	tysc,w			; 
				call 	deshif			; 
				movwf	tysc			;
				movf	sotn,w			; 
				call 	deshif			; 
				movwf	sotn			;
				movf	dest,w			; 
				call 	deshif			; 
				movwf	dest			;
				movf	edin,w			; 
				call 	deshif			; 
				movwf	edin			;
;===============================================
	;			movfw	t_binu			; 
	;			movwf	binu			; 
				movfw	t_binh			; 
				movwf	binh			; 
				movfw	t_binl			; 
				movwf	binl			; 
;===============================================
		retlw   0			;   
;===============================================
adjDEC 		 	movlw   R0				;
				movwf   FSR				;
				call    adjBCD			;
		 		movlw   R1				;
				movwf   FSR				;
				call    adjBCD			;
				movlw   R2				;
				movwf   FSR				;
				call    adjBCD			;
				movlw   R3				;
				movwf   FSR				;
				call    adjBCD			;
			goto    loop24				;
;===============================================
adjBCD 			movlw   3				;
				addwf   0,W				;
				movwf   temp			;
				btfsc   temp,3          ; test if result > 7
				movwf   0				;
				movlw   30				;
				addwf   0,W				;
				movwf   temp			;
				btfsc   temp,7          ; test if result > 7
				movwf   0    	        ; save as MSD
		RETLW   0						;
;===========================================================================================
;===========================================================================================
;                     ( 16x16 -> 32 )
;        ,;  -  ,  -  
D_mpyS			movf    peAsh,W      	;
				xorwf   peBsh,W     	;
				movwf  	sign     		;
				btfss   peBsh,7       	; if MSB set go & negate ACCb
		goto    $+6     				;
   				comf    peBsl,F      	;  
				incf    peBsl,F     	;
				btfsc   STATUS,Z     	;
				decf    peBsh,F     	;
				comf    peBsh,F     	;
		 		btfss   peAsh,7    		; if MSB set go & negate ACCa
		goto	$+6     				;
		  		comf    peAsl,F   		;  
				incf    peAsl,F	     	;
				btfsc   STATUS,Z     	;
				decf    peAsh,F     	;
				comf    peAsh,F     	;
  				
				movlw   .16        		; for 16 shifts
				movwf  	temp     		;
				movf    peBsh,W      	;move b to d
				movwf  	peDsh     		;
				movf    peBsl,W     	;
				movwf  	peDsl    	 	;
				clrf    peBsh    	 	;
				clrf    peBsl    	 	;
				
				call	mulMac   	  	;
				decfsz	temp,f   	  	;
				goto	$-2     		;
				
				btfss   sign,7   	  	;
		retlw   0     					;
				comf    peCsl,F    		;  CB ( -CB -> CB )
				comf    peCsh,F     	;
				comf    peBsl,F     	;
				comf    peBsh,F     	;
				incf    peCsl,F     	;
				btfsc   STATUS,Z     	;
				incf	peCsh,F     	;
				btfsc   STATUS,Z     	;
				incf	peBsl,F     	;
				btfsc  	STATUS,Z     	;
				incf   	peBsh,F     	;
	retlw   0    					 	;
;**********************************
mulMac			rrf     peDsh,F   		;  d 
				rrf     peDsl,F     	;
				btfss   STATUS,C   		;need to add?
			goto    NO_ADD         		; no addition necessary
				movf    peAsl,W     	; Addition ( ACCb + ACCa -> ACCb )
				addwf   peBsl,F      	;add lsb
				btfsc   STATUS,C    	;add in carry
				incf    peBsh,F     	;
				movf    peAsh,W     	;
				addwf   peBsh,F     	;add msb
NO_ADD  		rrf     peBsh,F     	;
				rrf     peBsl,F     	;
				rrf     peCsh,F     	;
				rrf     peCsl,F     	;
	return   						  	;
;===========================================================================================
       
;       24/24 Bit Unsigned Fixed Point Divide 24/24 -> 24.24

;            24/24  

;       Input:  24 bit       -  peAsu, peAsh,peAsl
;               24 bit       - peBsu, peBsh, peBsl
;       Use:    CALL    FXD2424U
;       Output: 24 bit       - peAsu, peAsh,peAsl
;               24 bit       - peCsu, peCsh, peCsl

;       Result: AARG, REM  <--  AARG / BARG
;       Max Timing:     3+671+2 = 676 clks
;       Max Timing:     3+639+2 = 644 clks
;       PM: 3+222+1 = 226               DM: 13

FXD2424U   		CLRF            peCsu
           		CLRF            peCsh
           		CLRF            peCsl

                CLRF            temp

                RLF             peAsu,W
                RLF             peCsl, F
                MOVF            peBsl,W
                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F

                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                RLF             peAsu, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424A      RLF             peAsu,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsu,0
                GOTO            UADD44LA

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LA

UADD44LA        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LA 		RLF             peAsu, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424A

                RLF             peAsh,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsu,0
                GOTO            UADD44L8

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44L8

UADD44L8        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44L8         RLF             peAsh, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424B      RLF             peAsh,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsh,0
                GOTO            UADD44LB

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LB

UADD44LB        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LB         RLF             peAsh, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424B

                RLF             peAsl,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsh,0
                GOTO            UADD44L16

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44L16

UADD44L16       ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44L16        RLF             peAsl, F

                MOVLW           7
                MOVWF           regsr

LOOPU2424C      RLF             peAsl,W
                RLF             peCsl, F
                RLF             peCsh, F
                RLF             peCsu, F
                RLF             temp, F
                MOVF            peBsl,W
                BTFSS           peAsl,0
                GOTO            UADD44LC

                SUBWF           peCsl, F
                MOVF            peBsh,W
                BTFSS           STATUS,C
                INCFSZ          peBsh,W
                SUBWF           peCsh, F
                MOVF            peBsu,W
                BTFSS           STATUS,C
                INCFSZ          peBsu,W
                SUBWF           peCsu, F
                MOVLW  .0
                BTFSS           STATUS,C
                MOVLW           1
                SUBWF           temp, F
                GOTO            UOK44LC

UADD44LC        ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
                MOVLW  .0
                BTFSC           STATUS,C
                MOVLW           1
                ADDWF           temp, F
        
UOK44LC 		RLF             peAsl, F

                DECFSZ          regsr, F
                GOTO            LOOPU2424C

                BTFSC           peAsl,0
                GOTO            UOK44L
                MOVF            peBsl,W
	        	ADDWF           peCsl, F
                MOVF            peBsh,W
                BTFSC           STATUS,C
                INCFSZ          peBsh,W
                ADDWF           peCsh, F
                MOVF            peBsu,W
                BTFSC           STATUS,C
                INCFSZ          peBsu,W
                ADDWF           peCsu, F
UOK44L
         RETLW           0x00
;===========================================================================================



;=======================================================================================
;* subroutine:  
;*  				fssh, fssh -     
;*     	SIN_hi, SIN_lo    
;*   				sred_dr    (  SIN_hi)
;*   	temp1, temp2
;  
;		movlw	min1_hi				;   
;		call	average				;    

;    2 ^ (n-1) x   +  
; = ---------------------------------
;               (2 ^ n)
#define		kolusre	.2						;   2-8
;---------------------------------------------------------------------------------------
;{
average										;

		;	movf	SIN_hi,w					;
		;	movwf	sred_hi					;
		;	movf	SIN_lo,w					; 
		;	movwf	sred_lo					; 
			
average_m		
	        movf    sred_hi,w				;    
	        movwf   sred_hi_temp			; 
	        movf    sred_lo,w				; 
	        movwf   sred_lo_temp			; 
	        clrf    temp2           		; 
	
	        call    divideby2pwrn   		;    n -  n  .
;******
	        movf    temp2,w         		; 
	        subwf   sred_dr,f 		;    
	        btfsc   STATUS,C         		; 
        goto    hopover   		      		; 
	        decf    sred_lo,f         		; 
	        movlw   .255         			; 
	        xorwf   sred_lo,w         		; 
	        btfsc   STATUS,Z         		; 
	        decf    sred_hi,f         	   	;        
hopover
	        movf    sred_lo_temp,w   	  	; 
	        subwf   sred_lo,f         		; 
	        btfss   STATUS,C         		; 
	        decf    sred_hi,f         		; 
	
	        movf    sred_hi_temp,w    		; 
	        subwf   sred_hi,f     	  		; average - 1/(2^n)
;******
	        movf    fssh,w         			; 
	        movwf   sred_hi_temp     	  	; 
	        movf    fssl,w         			; 
	        movwf   sred_lo_temp     	   	; make a copy of the original value
	        clrf    temp2      		 	  	; 
	
	        call    divideby2pwrn  		 	;    n -  n  .
	
	        movf    temp2,w      		   	; 
	        addwf   sred_dr,f        		; 
	        btfss   STATUS,C      		   	; 
        goto    hopover2      		   		; 
	        incf    sred_lo,f      		   	; 
	        btfsc   STATUS,Z      		   	; 
	        incf    sred_hi,f      		   	; 
hopover2
	        movf    sred_lo_temp,w         	; 
	        addwf   sred_lo,f      		   	; 
	        btfsc   STATUS,C      		   	; 
	        incf    sred_hi,f      		   	; 
	        movf    sred_hi_temp,w         	; 
	        addwf   sred_hi,f      		   	; 


			movf	sred_lo,w				; 
			movwf	SIN_lo					; 
			movf	sred_hi,w				; 
			movwf	SIN_hi					;
 
        retlw   .0      				   	; 

divideby2pwrn		;     2^kolusre
	        movlw   kolusre					;
	        movwf   temp1     	 		   	; 
shift1    						  		 	;
	        bcf     STATUS,C      		   	; 
	        rrf     sred_hi_temp,f      	; 
	        rrf     sred_lo_temp,f      	; 
	        rrf     temp2,f      		   	; 
	        decfsz  temp1,f      		   	; 
        goto    shift1      		  	 	; 
			clrwdt						;   ++++++	
      retlw   .0      		  		 	; 
;}
;=======================================================================================



;===========================================================================================
				FILL(goto 0x00),0x800-$   ;     



;============================================================================================										
;++++++++++++++++++++++++++    EEPROM +++++++++++++++++++++++++++++++++++++++
			ORG		0x2100						; 
			DE		.0,.0 						; flaf_0						;* 
			DE		0x01,0x01,0xf4,0xf4			; T_zad		- 40.0%				;* 
			DE		.10,.10						; Gis_lo	- 1.0%				;* 
			DE		0x00,0x00,0xa9,0xa9			; k1_hi,k1_lo					;*   1 (169)
			DE		0x0b,0x0b,0x68,0x68			; k2_hi,k2_lo					;*   2 (2920)
			DE		0x12,0x12,0xb6,0xb6			; k3_hi,k3_lo					;*   3 (4790)
			DE		.0,.0						; 
;============================================================================================




	END                       ; directive 'end of program'

